﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'v.0.15 Circuit component object: a rectangle + pins

#Event: Click
#Event: LongClick

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	Public Name As String
	
	Public InternalView As Boolean
	Public mRoot As B4XView
	Public mRect As b4xVectEdit_rect
	Public PinIn1, PinIn2, PinIn3, PinOut As b4xVectEdit_pin
	
	Private DownX, DownY As Double, Dragging As Boolean, DraggingStart As Long
	Private GridSize As Int = 5dip
	Private MouseClickTimer As Timer	'LongTap timer for Android together with dragging
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	MouseClickTimer.Initialize("MouseClickTimer", 500)
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mBase.SetColorAndBorder(xui.Color_Transparent, 1dip, xui.Color_Transparent, 0)	'transparent container xui.Color_ARGB(50, 0, 0, 0)
    Tag = mBase.Tag
    mBase.Tag = Me
	
	mRoot = xui.CreatePanel("mRoot")
	If InternalView Then
		mBase.AddView(mRoot, 0, 0, mBase.Width, mBase.Height)	'component is on the parent
	Else
		mBase.Parent.AddView(mRoot, 0, 0, mBase.Width, mBase.Height)	'component is on the parent
		'mBase.RemoveViewFromParent	'the view container is removed
	End If
	
	#if B4A
		Dim r As Reflector
		r.Target = mRoot
		r.SetOnTouchListener("mRoot_Touch") 'https://www.b4x.com/android/forum/threads/how-correct-crossplatform-mouse-object-moving-dragging-by-_touch-event.160800/#post-986957
	#End If
	
	
	'first figure as content of this component
	mRect.Initialize(Me, "mRect")
	mRect.DesignerCreateView(mRoot, Null, Null)
	
	'second figure as content of this component
	PinIn1.Initialize(Me, "PinIn1")
	PinIn1.DesignerCreateView(mRoot, Null, Null)
	PinIn1.mRoot.Top = mRect.mRect.Top + mRect.SideGap * 2
	PinIn1.Name = mEventName & "_PinIn1"
	
	PinIn2.Initialize(Me, "PinIn2")
	PinIn2.DesignerCreateView(mRoot, Null, Null)
	PinIn2.mRoot.Top = PinIn1.mRoot.Top + mRect.SideGap * 2
	PinIn2.Name = mEventName & "_PinIn2"
	
	PinIn3.Initialize(Me, "PinIn3")
	PinIn3.DesignerCreateView(mRoot, Null, Null)
	PinIn3.mRoot.Top = PinIn2.mRoot.Top + mRect.SideGap * 2
	PinIn3.Name = mEventName & "_PinIn3"
	
	PinOut.Initialize(Me, "PinOut")
	PinOut.DesignerCreateView(mRoot, Null, Null)
	PinOut.mRoot.Top = mRect.mRect.Top + mRect.SideGap * 2
	PinOut.mRoot.Left = mRect.mRect.Left + mRect.mRect.Width - mRect.SideGap * 2
	PinOut.Name = mEventName & "_Out"
	
	DownX = mRoot.Left
	DownY = mRoot.Top
	Base_Resize(mBase.Width, mBase.Height)
End Sub


'TOUCH_ACTION_DOWN = 0
'TOUCH_ACTION_MOVE = 2
'TOUCH_ACTION_UP = 1
'TOUCH_ACTION_MOVE_NOTOUCH = 100
#if B4A
Private Sub mRoot_Touch (o As Object, ACTION As Int, x As Float, y As Float, motion As Object) As Boolean
#else
Private Sub mRoot_Touch (Action As Int, X As Float, Y As Float)
#end if
	If InternalView Then Return
	If Action = mRoot.TOUCH_ACTION_DOWN Then
		mRoot.BringToFront
		Dragging = True
		DownX = X
		DownY = Y
		DraggingStart = DateTime.Now
		Check_LongClick	'checking if LongTap was made
	Else If Action = mRoot.TOUCH_ACTION_UP Then
		Dragging = False
		MouseClickTimer.Enabled = False	'no LongTap
	Else If Dragging And Action = mRoot.TOUCH_ACTION_MOVE Then
		MouseClickTimer.Enabled = False	'no LongTap
		mRoot.Left = Max(0, Min(mRoot.Parent.Width - mRoot.Width, ApplyGrid(mRoot.Left + X - DownX)))
		mRoot.Top = Max(0, Min(mRoot.Parent.Height - mRoot.Height, ApplyGrid(mRoot.Top + Y - DownY)))
	End If
    #if B4A
	Return True
    #end if
End Sub

Private Sub Check_LongClick
	#if B4A
	MouseClickTimer.Enabled = True
	Wait For MouseClickTimer_Tick
	MouseClickTimer.Enabled = False
	If (DateTime.Now - DraggingStart) > MouseClickTimer.Interval And (DateTime.Now - DraggingStart) < 1000 Then
		mRoot_LongClick
	End If
	#end if
End Sub

Private Sub ApplyGrid (x As Int) As Int
	If GridSize > 0 Then
		Return x - (x Mod GridSize)
	End If
	Return x
End Sub

Sub Base_Resize (Width As Double, Height As Double)
	mRoot.SetLayoutAnimated(0, 0, 0, Width, Height)
	mRect.Base_Resize(Width, Height)
	PinOut.mRoot.Left = mRect.mRect.Left + mRect.mRect.Width - mRect.SideGap * 2
	Sleep(0)
End Sub

#if B4J
Private Sub mRoot_MouseClicked (EventData As MouseEvent)
	If Dragging Then Return
	If EventData.PrimaryButtonPressed Then
'		Log("mRoot click: " & Name)
'		If xui.SubExists(mCallBack, mEventmEventName & "_Click", 0) Then
'			CallSub(mCallBack, mEventmEventName & "_Click")
'		End If
	Else if EventData.SecondaryButtonPressed Then
		Log("mRoot longclick: " & Name)
		If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
			CallSub(mCallBack, mEventName & "_LongClick")
		End If
	End If
	EventData.Consume
End Sub
#else if B4A
Private Sub mRoot_Click
'	Log("mRoot click: " & Name)
'	If xui.SubExists(mCallBack, mEventmEventName & "_Click", 0) Then
'		CallSub(mCallBack, mEventmEventName & "_Click")
'	End If
End Sub
Private Sub mRoot_LongClick
	Log("mRoot longclick: " & Name)
	If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
		CallSub(mCallBack, mEventName & "_LongClick")
	End If
End Sub
#end if
